<script lang="ts">
  import {
    cardSuit,
    getClaims,
    getSuitCounts,
    groupBySuits,
    isActivePlayer,
    suits,
  } from "../utils";
  import CardBack from "./CardBack.svelte";
  import CardFront from "./CardFront.svelte";
  import { createEventDispatcher } from "svelte";
  import { send, receive } from "./cardCrossfade";
  import { flip } from "svelte/animate";
  import { slide } from "svelte/transition";
  import SuitIcon from "./SuitIcon.svelte";

  const dispatch = createEventDispatcher();
  function dispatchAction(action: Action) {
    dispatch("action", action);
  }
  export let userId: PlayerId;
  export let state: GameState;
  export let player: Player;

  $: isUser = userId === player.id;
  $: cards = [...player.hand];
  $: {
    if (isUser) {
      cards.sort((a, b) => a - b);
    }
  }

  let selectedSuit: Suit | null = null;
  let selectedTarget: PlayerId | null = null;

  let selectedPassReceiver: PlayerId | null = null;
  let selectedPassSuit: Suit | null = null;

  let acceptCardBelief: "true" | "false" | null = null;

  $: cardsClickable =
    state.phase[0] === "Giving"
      ? selectedSuit !== null && selectedTarget !== null
      : false;

  $: isSpeaking =
    getClaims(state).some((p) => p.giver === player.id) ||
    (state.phase[0] === "Passing" && state.phase[1].giver === player.id) ||
    (state.phase[0] === "Acceptance" &&
      (state.phase[1].claim.giver === player.id ||
        state.phase[1].claim.receiver === player.id));

  $: palmedCardGroups = groupBySuits(player.palmed);

  $: palmedCounts = getSuitCounts(player.palmed);

  $: claim = getClaims(state).find((c) => c.giver == player.id);
</script>

<div class="wrapper">
  <ul class="cards" class:user={isUser}>
    {#each cards as card, idx (card)}
      <li style={`--card-angle: ${((-cards.length + 1) / 2 + idx) * 2.1}deg;`}>
        <div in:receive={{ key: card }} out:send={{ key: card }}>
          {#if isUser}
            <button
              class="card-button"
              disabled={!cardsClickable}
              on:click={() => {
                if (
                  state.phase[0] === "Giving" &&
                  selectedSuit !== null &&
                  selectedTarget !== null
                ) {
                  dispatchAction([
                    "Give",
                    {
                      actual: card,
                      claimed: selectedSuit,
                      receiver: selectedTarget,
                    },
                  ]);
                }
              }}
            >
              <CardFront {card} />
            </button>
          {:else}
            <CardBack />
          {/if}
        </div>
      </li>
    {/each}
  </ul>

  <gs6-player-box
    speaking={isSpeaking}
    userid={player.id}
    thinking={isActivePlayer(state, player.id)}
  >
    {#if isSpeaking}
      <div slot="speech">
        {#if claim}
          Here,
          <gs6-user userid={claim.receiver} suffix="." />
          It's a <SuitIcon suit={claim.suit} />.
        {:else if state.phase[0] === "Passing" && state.phase[1].giver === player.id}
          I'm passing it!
        {:else if state.phase[0] === "Acceptance"}
          {#if player.id === state.phase[1].claim.receiver}
            {#if state.phase[1].belief}
              It's true!
            {:else}
              You're lying!
            {/if}
          {:else if player.id === state.phase[1].claim.giver}
            {#if (cardSuit(state.phase[1].actual) === state.phase[1].claim.suit) === state.phase[1].belief}
              You're right!
            {:else}
              You're wrong!
            {/if}
          {/if}
        {/if}
      </div>
    {/if}

    {#if palmedCounts.size > 0}
      <div class="content">
        <div class="palmed-cards">
          {#each palmedCardGroups as group (cardSuit(group[0]))}
            <span animate:flip transition:slide>
              {#each group as card (card)}
                <span
                  class="palmed-card-suit"
                  in:receive={{ key: card }}
                  out:send={{ key: card }}
                >
                  <SuitIcon suit={cardSuit(card)} />
                </span>
              {/each}
              <strong>× {group.length}</strong>
            </span>
          {/each}
        </div>
      </div>
    {/if}
  </gs6-player-box>

  {#if state.phase[0] === "Receiving" && state.phase[1].claim.receiver === player.id}
    {#each [state.phase[1].actual] as card (card)}
      <div class="player-received-card">
        <div in:receive={{ key: card }} out:send={{ key: card }}>
          <CardBack />
        </div>
      </div>
    {/each}
  {:else if state.phase[0] === "Passing" && state.phase[1].giver === player.id}
    {#each [state.phase[1].card] as card (card)}
      <div class="player-received-card">
        <div in:receive={{ key: card }} out:send={{ key: card }}>
          {#if userId === player.id}
            <CardFront {card} />
          {:else}
            <CardBack />
          {/if}
        </div>
      </div>
    {/each}
  {:else if state.phase[0] === "Acceptance" && state.phase[1].claim.receiver === player.id}
    {#each [state.phase[1].actual] as card (card)}
      <div class="player-received-card">
        <div in:receive={{ key: card }} out:send={{ key: card }}>
          <CardFront {card} />
        </div>
      </div>
    {/each}
  {/if}

  {#if isUser && state.phase[0] === "Giving" && state.phase[1].giver === player.id}
    <div class="player-action panel border shadow">
      Give card to
      <ul class="action-targets">
        {#each state.players.filter((p) => p.id !== player.id) as target (target.id)}
          <li class="action-target">
            <label>
              <input
                type="radio"
                value={target.id}
                bind:group={selectedTarget}
              />
              <gs6-user userid={target.id} />
            </label>
          </li>
        {/each}
      </ul>
      and say it's a
      <ul class="action-suits">
        {#each suits as suit (suit)}
          <li class="action-suit">
            <label>
              <input type="radio" value={suit} bind:group={selectedSuit} />
              <SuitIcon {suit} />
            </label>
          </li>
        {/each}
      </ul>

      {#if selectedTarget !== null && selectedSuit !== null}
        <i>Click a card in your hand.</i>
      {/if}
    </div>
  {:else if isUser && state.phase[0] === "Receiving" && state.phase[1].claim.receiver === player.id}
    <div class="player-action receiving panel border shadow">
      <p>
        {#each getClaims(state).filter((claim) => claim.receiver === player.id) as claim}
          <gs6-user userid={claim.giver} />
          has given you a card. They say it's a
          <br />
          <span style:font-size="150%">
            <SuitIcon suit={state.phase[1].claim.suit} />
          </span>.
        {/each}
      </p>
      <ul class="receiving-options">
        <li>
          <label>
            <input type="radio" value="true" bind:group={acceptCardBelief} />
            It's true!
          </label>
        </li>
        <li>
          <label>
            <input type="radio" value="false" bind:group={acceptCardBelief} />
            They're lying!
          </label>
        </li>
      </ul>

      <div style="white-space: nowrap">
        <button
          class="secondary"
          disabled={getClaims(state).length >= state.players.length - 1}
          on:click={() => dispatchAction(["Peek", []])}
        >
          Pass it
        </button>
        <button
          class="primary"
          disabled={acceptCardBelief === null}
          on:click={() =>
            dispatchAction(["Accept", { belief: acceptCardBelief === "true" }])}
        >
          Guess
        </button>
      </div>
    </div>
  {:else if isUser && state.phase[0] === "Acceptance" && isActivePlayer(state, player.id)}
    <div class="player-action">
      <button class="primary" on:click={() => dispatchAction(["Ready", []])}>
        Ready
      </button>
    </div>
  {:else if isUser && state.phase[0] === "Passing" && state.phase[1].giver === player.id}
    <div class="player-action panel border shadow">
      {#each getClaims(state).filter((claim) => claim.receiver === player.id) as claim}
        <div>
          <gs6-user userid={claim.giver} />
          gave you a
          <span style:font-size="150%">
            <SuitIcon suit={cardSuit(state.phase[1].card)} />
          </span>.
        </div>
      {/each}
      <div>Pass it to</div>

      <ul class="action-targets">
        {#each state.players.filter((p) => p.id !== player.id) as target (target.id)}
          <li class="action-target">
            <label>
              <input
                type="radio"
                value={target.id}
                disabled={getClaims(state).some((c) => c.giver === target.id)}
                bind:group={selectedPassReceiver}
              />
              <span
                class:disabled={getClaims(state).some(
                  (c) => c.giver === target.id
                )}
              >
                <gs6-user userid={target.id} />
              </span>
            </label>
          </li>
        {/each}
      </ul>
      and say it's a
      <ul class="action-suits">
        {#each suits as suit (suit)}
          <li class="action-suit">
            <label>
              <input type="radio" value={suit} bind:group={selectedPassSuit} />
              <SuitIcon {suit} />
            </label>
          </li>
        {/each}
      </ul>

      <button
        class="primary"
        disabled={selectedPassReceiver === null || selectedPassSuit === null}
        on:click={() => {
          if (
            state.phase[0] === "Passing" &&
            selectedPassReceiver !== null &&
            selectedPassSuit !== null
          ) {
            dispatchAction([
              "Pass",
              {
                claimed: selectedPassSuit,
                receiver: selectedPassReceiver,
              },
            ]);
          }
        }}
      >
        Pass card
      </button>
    </div>
  {/if}
</div>

<style>
  .wrapper {
    position: relative;
    margin-top: 2.5em;
  }

  .cards {
    margin: 0;
    position: relative;

    font-size: 0.33em;
    display: flex;
  }
  .cards.user {
    font-size: 0.67em;
  }

  .cards > li {
    position: absolute;

    left: 50%;
    top: 2rem;

    transform: translate(-50%, -100%) translateY(600%)
      rotateZ(var(--card-angle)) translateY(-600%);
    margin: 0;
    transition: transform 0.4s;
  }

  .card-button {
    font-size: inherit;
    border: 0;
    padding: 0;
    transition: transform 0.2s;
  }
  .card-button:not(:disabled):hover,
  .card-button:not(:disabled):focus {
    cursor: pointer;
    transform: translateY(-2em);
  }
  .card-button:disabled {
    color: inherit;
    background-color: inherit;
  }

  .player-action {
    /* max-width: 18rem; */
    min-width: 16rem;
    position: absolute;
    top: -9rem;
    left: 50%;
    transform: translate(-50%, -100%);

    display: flex;
    gap: 1em;
    flex-direction: column;
    align-items: center;
    justify-content: space-between;
    text-align: center;
  }
  .player-action.receiving {
    min-width: 24rem;
  }
  .receiving-options {
    display: flex;
    gap: 1rem;
  }
  .player-action > * {
    margin: 0;
  }
  .player-action > ul {
    text-align: left;
  }

  .player-action > i {
    font-weight: 300;
  }

  .action-target {
    white-space: nowrap;
  }
  .action-target .disabled {
    filter: opacity(0.5);
  }

  .action-targets {
    display: flex;
    flex-wrap: wrap;
    gap: 0.25rem 1rem;
  }
  .action-targets > * {
    width: calc(50% - 1rem);
  }

  .action-suits {
    font-size: 1.25em;

    width: 14em;
    display: flex;
    flex-wrap: wrap;
    justify-content: space-around;
  }
  .action-suit {
    margin-inline-start: 0.33em;
    margin-inline-end: 0.33em;
  }

  .palmed-cards {
    display: flex;
    flex-wrap: wrap;
    max-width: 11rem;
    justify-content: center;
    gap: 0.25rem 1rem;
  }
  .palmed-cards > * {
    width: 3rem;
    white-space: nowrap;
    text-align: center;
  }
  .palmed-card-suit:not(:first-of-type) {
    position: absolute;
    opacity: 0;
  }

  .player-received-card {
    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, 100%) translateY(-0.5rem);
    font-size: 0.33em;
  }
</style>
